library ieee;
  use ieee.std_logic_1164.all;
  
entity AvalonTrans is
  port 
  (

		CLK 			: in  std_logic;
		RST 			: in  std_logic;

		--Avalon       
		chipselect		: in 	std_logic;
		write 			: in 	std_logic;
		read 			: in 	std_logic;
		address 		: in 	std_logic_vector(15 downto 0);
		writedata 		: in 	std_logic_vector(31 downto 0);
		readdata 		: out 	std_logic_vector(31 downto 0);		

		-- OPB
		OPB_DBus_out 	: in  	std_logic_vector(31 downto 0);
		OPB_XferAck 	: in  	std_logic;
		OPB_retry 		: in  	std_logic;
		OPB_toutSup 	: in  	std_logic;
		OPB_errAck 		: in  	std_logic;
		OPB_ABus 		: out 	std_logic_vector(31 downto 0);
		OPB_BE 			: out 	std_logic_vector(3 downto 0);
		OPB_DBus_in 	: out 	std_logic_vector(31 downto 0);
		OPB_RNW 		: out 	std_logic;
		OPB_select 		: out 	std_logic
		
	);
	
end AvalonTrans;

architecture rtl of AvalonTrans is

begin

	OPB_ABus <= (X"0000" & address) when chipselect = '1' else (others => '0');
	OPB_BE <= X"F" when chipselect = '1' else X"0";
	OPB_RNW	<= '1' when chipselect = '1' and read = '1' else '0';
	OPB_DBus_in <= writedata when chipselect = '1' and write = '1' else (others => '0');
	readdata <= OPB_DBus_out when chipselect = '1' and read = '1' else (others => '0');
	OPB_select <= chipselect; 

end rtl;
