#include <io.h>
#include <system.h>
#include <stdio.h>
#include "gui.h"

struct image images[MAX_NUM_IMAGES];

struct image *current_image;
struct image *prev_image = NULL;
int num_images = 0;
int current_image_num = 0;

int initialize_gui() 
{
    send_thumbnails();
    // initialize images
    current_image = &images[0];
    current_image->image_num = 0;
    current_image->is_taken = 0;
    current_image->prev = current_image;
    current_image->next = current_image;
    
    int save_image_req = 0;
    int send_image_req = 0;
    int del_image_req = 0;
    int send_thumbnails_req;
    /*
    for (;;)
    {
        // send number of stored images
        IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 24, current_image_num);
        // check if need to get image
        save_image_req = IORD_16DIRECT(TV_TO_VGA_INST_BASE, 8);
        send_image_req = IORD_16DIRECT(TV_TO_VGA_INST_BASE, 20);
        del_image_req = IORD_16DIRECT(TV_TO_VGA_INST_BASE, 26);
        
        //check if need to refresh thumbnails
        //send_thumbnails_req = IORD_16DIRECT(TV_TO_VGA_INST_BASE, 52);
        if (send_thumbnails_req == 1)
        {
                //send_thumbnails();
        }
        else if (save_image_req == 1 && num_images < MAX_NUM_IMAGES)
        {
           // printf("saving-----%d\n", send_image_req);
            save_image();
            //write_image();
        }
        else if (num_images >= 1 && send_image_req != 0 && save_image_req != 1)
        {
            send_image(send_image_req);
        }
        else if (del_image_req == 1 && num_images > 0)
        {
            delete_current_image();
        }
        del_image_req = 0;
        send_image_req = 0;
        save_image_req = 0;
    }*/
}

int get_current_img_num()
{
    return current_image->image_num;
}

int get_num_images()
{
    return num_images;
}

int freeze = 0;
void freeze_toggle()
{
    freeze = !freeze;
    printf("freeze: %d\n", freeze);
    IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 50, freeze);
}

void full_screen(int is_full_screen)
{
    IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 52, is_full_screen);   
}

void delete_current_image()
{
    printf("deleting image:\n");
    current_image->prev->next = current_image->next;
    current_image->next->prev = current_image->prev;
    current_image->is_taken = 0;
    num_images--;
    
    if (num_images != 0)
        send_image(2);
    else
        send_image(2);
    printf("number of images: %d\n", num_images);
}

void send_image(int direction)
{
    
    current_image = (direction == 2) ? current_image->next :
                    current_image->prev;
    printf("current image: %d\n", current_image->image_num);
    int i = current_image->image_num;
    printf("sending image\n");
    unsigned char byte_r, byte_g, byte_b;
    int pixel;
    int x, y;
    //int y_start = (direction == 2) ? 0 : IMG_Y_SIZE;
    //int y_end = (direction == 1) ? 0 : IMG_Y_SIZE;
    //int y_inc = (direction == 2) ? 1 : -1;
    int x_start = (direction == 2) ? 0 : IMG_X_SIZE;
    int x_end = (direction == 1) ? 0 : IMG_X_SIZE;
    int x_inc = (direction == 2) ? 1 : -1;
    //for (y = y_start; (y < y_end && direction == 2) || (y > y_end && direction == 1); y += y_inc)
    //{
      //  for(x = 0; x < IMG_X_SIZE; x += 1)
        //{
    for (x = x_start; (x < x_end && direction == 2) || (x > x_end && direction == 1); x += x_inc)
    {
        for(y = 0; y < IMG_Y_SIZE; y += 1)
        {
            
            // send request
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 16, 1);
            
            // set requested x and y positions
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 10, x);
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 12, y);
            
            // get pixel from memory
            byte_r = saved_images[i][0][y][x];
            byte_g = saved_images[i][1][y][x];
            byte_b = saved_images[i][2][y][x];

            if (num_images == 0)
                pixel = 0;
            else
                pixel = ((byte_r >> 3) << 11) | ((byte_g >> 2) << 5) |((byte_b >> 3) << 0); 
            
            // send pixel
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 14, pixel); 
            
            // reset request
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 16, 0);
        }
    }
    printf("sent\n");
}

int save_remote_image()
{
    printf("creating new image\n");
    
    num_images++;
    printf("num images: %d\n", num_images);
    
    unsigned char byte_r, byte_g, byte_b;
    int pixel;
    int x, y; 
    
    // find next free slot
    int i;
    for (i = 0; i < MAX_NUM_IMAGES; i++)
    {
        if (!images[i].is_taken)
        {
            current_image = &images[i];
            break;
        }
    }
    
    if (prev_image == NULL)
    {
        current_image->prev = current_image;
        current_image->next = current_image;
    }
    else if (num_images == 2)
    {
        prev_image->prev = current_image;
        prev_image->next = current_image;
        current_image->prev = prev_image;
        current_image->next = prev_image;
    }
    else if (num_images >= 3)
    { 
        current_image->prev = prev_image;
        current_image->next = prev_image->next;
        prev_image->next->prev = current_image;
        prev_image->next = current_image;
        
    }
    current_image->is_taken = 1;
    current_image->image_num = i;
    prev_image = current_image;
    printf("image num: %d\n", i);
    // return image number
    return i;    
}

void save_image()
{
    num_images++;
    unsigned char byte_r, byte_g, byte_b;
    int pixel;
    int x, y; 
    
    // find next free slot
    int i;
    for (i = 0; i < MAX_NUM_IMAGES; i++)
    {
        if (!images[i].is_taken)
        {
            current_image = &images[i];
            break;
        }
    }
    
    if (prev_image == NULL)
    {
        current_image->prev = current_image;
        current_image->next = current_image;
    }
    else if (num_images == 2)
    {
        prev_image->prev = current_image;
        prev_image->next = current_image;
        current_image->prev = prev_image;
        current_image->next = prev_image;
    }
    else if (num_images >= 3)
    { 
        current_image->prev = prev_image;
        current_image->next = prev_image->next;
        prev_image->next->prev = current_image;
        prev_image->next = current_image;
        
    }
    current_image->is_taken = 1;
    current_image->image_num = i;
    prev_image = current_image;
    printf("saving image: %d/%d\n", i, num_images);
    for (y = 0; y < IMG_Y_SIZE; y += 1)
    {
        for(x = 0; x < IMG_X_SIZE; x += 1)
        {
            // send request
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 4, 1);
            
            // set requested x and y positions
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 0, x);
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 2, y);

            // get pixel data
            pixel = IORD_16DIRECT(TV_TO_VGA_INST_BASE, 6);
            
            // enter pixel data into image matrix
            byte_r = (unsigned char) (((pixel >> 11) & 0x1F) << 3);
            byte_g = (unsigned char) (((pixel >>  5) & 0x3F) << 2);
            byte_b = (unsigned char) (((pixel >>  0) & 0x1F) << 3);
            
            // save pixel
            saved_images[i][0][y][x] = byte_r;
            saved_images[i][1][y][x] = byte_g;
            saved_images[i][2][y][x] = byte_b;
        }
    }
    //write_image(current_image);
    /*struct image *iter = current_image;
    printf("printing images:\n");
    for (i = 0; i < MAX_NUM_IMAGES; i++)
    {
        printf("%d: %d\n", iter->image_num, iter->is_taken);
        iter = iter->next;
    }*/
    printf("saved\n");
    printf("number of images: %d\n", num_images);
    
}

void send_thumbnails()
{
    printf("sending thubnail\n");
    unsigned char byte_r, byte_g, byte_b;
    int pixel;
    int x, y;
    for (y = 0; y < THUMBNAIL_Y_SIZE; y += 1)
    {
        for(x = 0; x < THUMBNAIL_X_SIZE; x += 1)
        {
            
            // send request
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 48, 1);
            
            // set requested x and y positions
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 42, x);
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 44, y);
            
            // get pixel from memory
            byte_r = 200;
            byte_g = 50;
            byte_b = 250;

            if (num_images == 0)
                pixel = 0;
            else
                pixel = ((byte_r >> 3) << 11) | ((byte_g >> 2) << 5) |((byte_b >> 3) << 0); 
            
            // send pixel
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 46, pixel); 
            
            // reset request
            IOWR_16DIRECT(TV_TO_VGA_INST_BASE, 48, 0);
        }
    }
    printf("sent\n");
}





void write_image(struct image *image)
{
    int i = image->image_num;
    unsigned char BITMAP_HEADER[] = { 
        0x42, 0x4D, 0xA6, 0xAD, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x28, 0x00,
        0x00, 0x00, 0xE4, 0x02, 0x00, 0x00, 0x14, 0x00, 0x00, 0x00, 0x01, 0x00, 0x18, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x70, 0xAD, 0x00, 0x00, 0xEB, 0x0A, 0x00, 0x00, 0xEB, 0x0A, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00 
    };
    
    printf("Bitmap header size is %d\n", (int) sizeof(BITMAP_HEADER));
    int file_size = (IMG_X_SIZE*IMG_Y_SIZE) * 3 + sizeof(BITMAP_HEADER);
    
    // write byte 0 (LSB)
    BITMAP_HEADER[FILE_SIZE_OFFSET+0] = (file_size >>  0) & 0xFF;
    // write byte 1 
    BITMAP_HEADER[FILE_SIZE_OFFSET+1] = (file_size >>  8) & 0xFF;
    // write byte 2 
    BITMAP_HEADER[FILE_SIZE_OFFSET+2] = (file_size >> 16) & 0xFF;
    // write byte 3 (MSB)
    BITMAP_HEADER[FILE_SIZE_OFFSET+3] = (file_size >> 24) & 0xFF;
    
    printf("Bitmap file size: %02X %02X %02X %02X\n", 
        BITMAP_HEADER[FILE_SIZE_OFFSET+0], 
        BITMAP_HEADER[FILE_SIZE_OFFSET+1],
        BITMAP_HEADER[FILE_SIZE_OFFSET+2],
        BITMAP_HEADER[FILE_SIZE_OFFSET+3]
    );
    
    // write byte 0 (LSB)
    BITMAP_HEADER[PIXEL_WIDTH_OFFSET+0] = (unsigned char)((IMG_X_SIZE >>  0) & 0xFF);
    // write byte 1    
    BITMAP_HEADER[PIXEL_WIDTH_OFFSET+1] = (unsigned char)((IMG_X_SIZE >>  8) & 0xFF);
    // write byte 2
    BITMAP_HEADER[PIXEL_WIDTH_OFFSET+2] = (unsigned char)((IMG_X_SIZE >> 16) & 0xFF);
    // write byte 3 (MSB)    
    BITMAP_HEADER[PIXEL_WIDTH_OFFSET+3] = (unsigned char)((IMG_X_SIZE >> 24) & 0xFF);
    
    printf("Bitmap width: %02X %02X %02X %02X\n", 
        BITMAP_HEADER[PIXEL_WIDTH_OFFSET], 
        BITMAP_HEADER[PIXEL_WIDTH_OFFSET+1],
        BITMAP_HEADER[PIXEL_WIDTH_OFFSET+2],
        BITMAP_HEADER[PIXEL_WIDTH_OFFSET+3]
    );    
    
    // write byte 0 (LSB)
    BITMAP_HEADER[PIXEL_HEIGHT_OFFSET+0] = (unsigned char)((IMG_Y_SIZE >>  0) & 0xFF);
    // write byte 1    
    BITMAP_HEADER[PIXEL_HEIGHT_OFFSET+1] = (unsigned char)((IMG_Y_SIZE >>  8) & 0xFF);
    // write byte 2
    BITMAP_HEADER[PIXEL_HEIGHT_OFFSET+2] = (unsigned char)((IMG_Y_SIZE >> 16) & 0xFF);
    // write byte 3 (MSB)    
    BITMAP_HEADER[PIXEL_HEIGHT_OFFSET+3] = (unsigned char)((IMG_Y_SIZE >> 24) & 0xFF);
    
    printf("Bitmap height: %02X %02X %02X %02X\n", 
        BITMAP_HEADER[PIXEL_HEIGHT_OFFSET], 
        BITMAP_HEADER[PIXEL_HEIGHT_OFFSET+1],
        BITMAP_HEADER[PIXEL_HEIGHT_OFFSET+2],
        BITMAP_HEADER[PIXEL_HEIGHT_OFFSET+3]
    );    
                
    FILE* fh = fopen(IMAGE_PATH, "wb");
    if(fh == NULL) {
      printf("Failed to open the file\n");
      return;
    }
    
    fwrite(BITMAP_HEADER, 1, sizeof(BITMAP_HEADER), fh);
    
    printf("Writing data: \n"); 
    int x, y, c;  
    for (y = 0; y < IMG_Y_SIZE; ++y)
    {
        printf(".");
        for(x = 0; x < IMG_X_SIZE; ++x) {
            for (c = 2; c >= 0; c--){
                fwrite(&saved_images[i][c][y][x], 1, sizeof(char), fh);
            }
        }
    }                      
    
    printf("\nDone!\n");

    fclose(fh);
    
    return;
}


