#include <time.h>
#include "basic_io.h"
#include "DM9000A.h"
#include "LCD.h"
#include "network.h"

void gotosleep(unsigned int seconds) {
  time_t before, now;
  before = now = time(NULL);  
  
  int elapsed = 0;
  while(1) {
    now = time(NULL);    
    if(before != now) {
      before = now;
      if(elapsed++ == seconds) return;            
    }   
  }
} // end gotosleep

// Initialize the display and ethernet interface
void alex_init() {
  // Initialize the LCD and display a welcome message
  LCD_Init();
  LCD_Show_Text("TEAM-SYNTHESIS");

  // Clear the LEDs to zero (will display interrupt count)
  outport(SEG7_DISPLAY_BASE, 0);

  printf("Network Transfer: Team-Synthesis (c) 2010\n");
  //printf("Initializing ethernet\n");

  network_init(); 
} // end init
